Itemtype matchItemtype(String s)
{
  Itemtype it = Itemtype.NONE;
  switch(s)
  {
    case "acdvd": it = Itemtype.acdvd; break;
    case "accd": it = Itemtype.accd; break;
    case "acbk": it = Itemtype.acbk; break;
    case "acvhs": it = Itemtype.acvhs; break;
  }
  return it;
}

String matchItemtype(Itemtype s)
{
  String it = "";
  switch(s)
  {
    case acdvd: it = "acdvd"; break;
    case accd: it = "accd"; break;
    case acbk: it = "acbk"; break;
    case acvhs: it = "acvhs"; break;
  }
  return it;
}

MovieName matchMovieName(int i)
{
  MovieName movie = MovieName.NONE;
  if(i <= 1)
    movie = MovieName.DeathProof;
  else if(i <= 4)
    movie = MovieName.DjangoUnchained;
  else if(i <= 6)
    movie = MovieName.HatefulEight;
  else if(i == 7)
    movie = MovieName.InglouriousBasterds;
  else if(i <= 11)
    movie = MovieName.JackieBrown;
  else if(i <= 13 || i == 16)
    movie = MovieName.KillBill1;
  else if(i <= 15)
    movie = MovieName.KillBill2;
  else if(i <= 22)
    movie = MovieName.PulpFiction;
  else
    movie = MovieName.ReservoirDogs;
  return movie;
}


int findReleasedYear(MovieName movie)
{
  int year = 0;
  switch(movie)
  {
    case DeathProof: year = 2007; break;
    case DjangoUnchained: year = 2012; break;
    case HatefulEight: year = 2015; break;
    case InglouriousBasterds: year = 2009; break;
    case JackieBrown: year = 1997; break;
    case KillBill1: year = 2003; break;
    case KillBill2: year = 2004; break;
    case PulpFiction: year = 1994; break;
    case ReservoirDogs: year = 1992; break;
  }
  // println("find movie year:", movie, year);
  return year;
}

MovieName findMovieName(int index)
{
  MovieName name = MovieName.NONE;
  switch(index)
  {
    case 5: name = MovieName.DeathProof; break;
    case 7: name = MovieName.DjangoUnchained; break;
    case 8: name = MovieName.HatefulEight; break;
    case 6: name = MovieName.InglouriousBasterds; break;
    case 2: name = MovieName.JackieBrown; break;
    case 3: name = MovieName.KillBill1; break;
    case 4: name = MovieName.KillBill2; break;
    case 1: name = MovieName.PulpFiction; break;
    case 0: name = MovieName.ReservoirDogs; break;
  }
  // println("find movie index:", movie, index);
  return name;
}

void readData()
{
  totalCheckoutsYearly = new float[MovieName.values().length - 1];
  for(int i = 0; i < t1.getRowCount(); i++)
  {
    int[] checkoutsEachYear = new int[YEARS];
    for(int j = 0; j < YEARS; j++)
    {
      checkoutsEachYear[j] = t1.getInt(i, j + STARTYEAR);
    }
    switch(matchMovieName(i))
    {
      // TODO: optimize
      case DeathProof: checkouts[5].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[5] = totalCheckoutsYearly[5] + t1.getFloat(i, TOTAL_COUNTS); break;
      case DjangoUnchained: checkouts[7].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[7] = totalCheckoutsYearly[7] + t1.getFloat(i, TOTAL_COUNTS);break;
      case HatefulEight: checkouts[8].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[8] = totalCheckoutsYearly[8] + t1.getFloat(i, TOTAL_COUNTS);break;
      case InglouriousBasterds: checkouts[6].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[6] = totalCheckoutsYearly[6] + t1.getFloat(i, TOTAL_COUNTS);break;
      case JackieBrown: checkouts[2].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[2] = totalCheckoutsYearly[2] + t1.getFloat(i, TOTAL_COUNTS);break;
      case KillBill1: checkouts[3].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[3] = totalCheckoutsYearly[3] + t1.getFloat(i, TOTAL_COUNTS);break;
      case KillBill2: checkouts[4].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[4] = totalCheckoutsYearly[4] + t1.getFloat(i, TOTAL_COUNTS);break;
      case PulpFiction: checkouts[1].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[1] = totalCheckoutsYearly[1] + t1.getFloat(i, TOTAL_COUNTS);break;
      case ReservoirDogs: checkouts[0].add(new Triplet(matchItemtype(t1.getString(i, ITEMTYPE)), matchMovieName(i), checkoutsEachYear)); totalCheckoutsYearly[0] = totalCheckoutsYearly[0] + t1.getFloat(i, TOTAL_COUNTS);break;
    }
  }
}

void printData()
{
  for(int i = 0; i < checkouts.length; i++)
  {
    for(int j = 0; j < checkouts[i].size(); j++)
    {
      print("movie: ", checkouts[i].get(j).second, "item type:", checkouts[i].get(j).first);
      Triplet<Itemtype, MovieName, int[]> temp = checkouts[i].get(j);
      for(int k = 0; k < temp.third.length; k++)
      {
        print(" ", temp.third[k]);
      }
      print("\n");
    }
  }
}

void getMaxMin()
{
  // get max and min
  for(int i = 0; i < t1.getRowCount(); i++)
  {
    if(maxCheckouts < t1.getInt(i, TOTAL_COUNTS))
      maxCheckouts = t1.getInt(i, TOTAL_COUNTS);
    if(minCheckouts > t1.getInt(i, TOTAL_COUNTS))
      minCheckouts = t1.getInt(i, TOTAL_COUNTS);
  }
}