void drawOrbit()
{
  for (int i = 0; i < MovieName.values().length - 1; i++)
  {
    stroke(#FFFFFF, 70  );
    strokeWeight(0.1);
    noFill();
    float currentRadius = radius * 2 / MovieName.values().length * (findReleasedYear(MovieName.values()[i]) - 1991);
    // print("current radius", currentRadius);
    pushMatrix();
    translate(0, 0, -100);
    ellipse(0, 0, currentRadius, currentRadius);
    popMatrix();
  }
}

void drawLine(int index)
{
  stroke(#ffffff, 100);
  strokeWeight(2);
  // println("allLines size", allLines.size());
  for (int k = 0; k < allLines[index].size(); k++)
  {
    PVector p1, p2;
    p1 = allLines[index].get(k).p1;
    p2 = allLines[index].get(k).p2;
    // println(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
    line(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
  }
  // allLines.clear();
}

//void drawLine(int index)
//{
//  ArrayList<Ptpair> allLines = new ArrayList();
//  // Queue<Ptpair> queue = new PriorityQueue<Ptpair>(10, new ComparetorByDist());
//  stroke(#ffffff, 100);
//  strokeWeight(2);
//  float size = map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 100);
//  for (int i = 0; i < allPoints[index].size(); i++)
//  {  
//    // noFill();
//    for (int j = 0; j < allPoints[index].get(i).length; j++)
//    {
//      PVector p1 = new PVector(allPoints[index].get(i)[j].x, allPoints[index].get(i)[j].y, allPoints[index].get(i)[j].z);
//      Queue<Ptpair> queue = new PriorityQueue<Ptpair>(10, new ComparetorByDist());
//      for (int m = i + 1; m < allPoints[index].size(); m++)
//      {  
//        for (int n = j + 1; n < allPoints[index].get(m).length; n++)
//        {
//          PVector p2 = new PVector(allPoints[index].get(m)[n].x, allPoints[index].get(m)[n].y, allPoints[index].get(m)[n].z);
//          Ptpair temp = new Ptpair(p1, p2, p1.dist(p2));
//          // temp.printPair();
//          if(queue.size() < 10)
//          {
//            queue.add(temp);
//            //temp.printPair();
//          }
//          else
//          {
//            Ptpair top = queue.peek();

//            if(top.dist > temp.dist)
//            {
//              top.printPair();
//              temp.printPair();
//              queue.poll();
//              queue.add(temp);
//            }
//          }
//        }
//      }

//      for(int x = 0; x < queue.size(); x++)
//      {
//        Ptpair top = queue.peek();
//        queue.poll();
//        allLines.add(top);
//      }
//    }
//  }
//  println(allLines.size());
//  for(int k = 0; k < allLines.size(); k++)
//  {
//    PVector p1, p2;
//    p1 = allLines.get(k).p1;
//    p2 = allLines.get(k).p2;
//    line(p1.x, p1.y, p1.z, p2.x, p2.y, p2.z);
//  }



//}

void drawDataPts()
{
  if (keyPressed == true)
  {
    if (key == '1')
      if (draw == false)
        draw = true;
      else
        draw = false;
  }
  for (int i = 0; i< allPoints.length; i++)
  {
    drawOneMovie(i);
  }
}

void drawOneMovie(int index)
{
  // {movieIndex, x, y, z, size, angle}
  float currentRadius = radius / MovieName.values().length * (findReleasedYear(findMovieName(index)) - 1991);
  float angle = startAngle[index] + frameCount * map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 0.005) % TWO_PI;
  float r = map(totalCheckoutsYearly[index], minCheckouts, maxCheckouts, 0, 100);
  pushMatrix();
  translate(currentRadius * cos(angle), currentRadius * sin(angle), -100 - r/8);
  for (int i = 0; i < allPoints[index].size(); i++)
  {  
    // noFill();
    for (int j = 0; j < allPoints[index].get(i).length; j++)
    {
      DataPoint pts = allPoints[index].get(i)[j];
      strokeWeight(pts.size);
      // println("pts size", pts.size);
      stroke(elementDetermine(findMovieName(index)), 150);
      point(pts.x, pts.y, pts.z);
    }
  }
  // drawLine(index);
  strokeWeight(2);
  stroke(elementDetermine(findMovieName(index)), 50);
  //noStroke();
  fill(elementDetermine(findMovieName(index)), 50);
  //sphereDetail(12);
  //sphere(r);
  if (index != 6)
    wrap[index].plot();

  if (draw == true)
    drawCoordinateSys(index);
  popMatrix();
}
void drawCoordinateSys(int index)
{

  // draw years
  pushMatrix();
  noFill();
  rotateY(PI/2);
  stroke(180);
  strokeWeight(1);
  ellipse(0, 0, 200, 200);

  for (int i = 0; i < YEARS - 1; i++) {
    noFill();
    pushMatrix();
    float theta = (i+1)*PI/13;
    translate(100*cos(theta+PI/2), 100*sin(theta+PI/2));
    rotate(theta+PI/2+PI);
    textAlign(LEFT, CENTER);
    fill(180);
    textSize(10);
    text(i + 2006, 1, 0);
    popMatrix();
  }
  popMatrix();

  // draw item type
  pushMatrix();
  noFill();
  rotateX(PI/2);
  stroke(180);
  strokeWeight(1);
  ellipse(0, 0, 200, 200);

  for (int i = 0; i < allPoints[index].size(); i++) {
    pushMatrix();
    float theta = i * TWO_PI / allPoints[index].size();
    translate(100*cos(theta+PI/2), 100*sin(theta+PI/2));
    rotate(theta+PI/2+PI);
    textAlign(RIGHT, CENTER);
    fill(180);
    textSize(12);
    text(matchItemtype(checkouts[index].get(i).first), 0, 0);
    popMatrix();
  }
  popMatrix();
}

void gui() {
  hint(DISABLE_DEPTH_TEST);
  cam.beginHUD();
  //textSize(10);
  //text("FPS: "+frameRate, 10, 10);
  drawNote();
  cam.endHUD();
  hint(ENABLE_DEPTH_TEST);
}

void drawNote()
{
  textSize(TEXTSIZE);
  fill(255, 255, 255);
  String s = "Quentin Tarantino";
  // text(s, centerX - TEXTSIZE * s.length() / 4, centerY + 5);
  String[] movieNames = {"Reservoir Dogs (1992)", "Pulp Fiction (1994)", "Jackie Brown (1997)", "Kill Bill: Volume 1 (2003)", "Kill Bill: Volume 2 (2004)", 
    "Death Proof (2007)", "Inglourious Basterds (2009)", "Django Unchained (2012)", "The Hateful Eight (2015)"};                   
  for (int j = 0; j < checkouts.length; j++)
  {
    text(movieNames[j], WIDTH - 0.3 * TEXTSIZE * movieNames.length, HEIGHT - (10 - j) * TEXTSIZE);
    strokeWeight(10);
    stroke(elementDetermine(j));
    point(WIDTH - 2.1 * TEXTSIZE * movieNames.length, HEIGHT - (10 - j) * TEXTSIZE - 4 );
    // text(movieNames[j], WIDTH - 0.3 * TEXTSIZE * movieNames.length, HEIGHT - (10 - j) * TEXTSIZE);
    //strokeWeight(6);
    //stroke(elementDetermine(j));
    //point(WIDTH - 2.1 * TEXTSIZE * movieNames.length, HEIGHT - (10 - j) * TEXTSIZE - 4 );
  }
  //s = "Quentin's Films";
  //textSize(TEXTSIZE * 1.5);
  //text(s, WIDTH - 1.4 * TEXTSIZE  * s.length() , HEIGHT - 14 * TEXTSIZE );
  //s =  "and His Oscar Years";
  //text(s, WIDTH - TEXTSIZE  * s.length() , HEIGHT - 12 * TEXTSIZE);
}